//=========================================================================
static char ray2_fragmenthader[] = \

"uniform vec4 fpar00[16];"
"uniform sampler2D tex00;"
"varying vec3 raydir;"

// sphere
"bool pri0(in vec4 sp,in vec3 ro,in vec3 rd,in float tm,out float t)"
"{"
    "bool r=false;"
    "vec3 d=ro-sp.xyz;"
    "float b=dot(rd,d);"
    "float c=dot(d,d)-sp.w*sp.w;"
    "t=b*b-c;"

    "if(t>0.0)"
        "{"
        "t=-b-sqrt(t);"
        "r=(t>0.0)&&(t<tm);"
        "}"

    "return r;"
"}"

// cylinder
"bool pri1(in vec4 sp,in vec3 ro,in vec3 rd,in float tm,out float t)"
"{"
    "bool r=false;"
    "vec3 d=ro-sp.xyz;"
    "float a=dot(rd.xz,rd.xz);"
    "float b=dot(rd.xz,d.xz);"
    "float c=dot(d.xz,d.xz)-sp.w*sp.w;"
    "t=b*b-a*c;"
    "if(t>0.0)"
        "{"
        "t=(-b-sqrt(t)*sign(sp.w))/a;"
        //"t=-b-sqrt(t);"
        //"t/=a;"
        "r=(t>0.0)&&(t<tm);"
        "}"
    "return r;"
"}"

// plane
"bool pri2(in vec4 pl,in vec3 ro,in vec3 rd,in float tm,out float t)"
"{"
#if 0
    "t=-(dot(pl.xyz,ro)+pl.w);"
    "t=t/dot(pl.xyz,rd);"
#else

    "float de=dot(pl.xyz,rd);"

    "de=sign(de)*max(abs(de),0.001);"

    "t=-(dot(pl.xyz,ro)+pl.w)/de;"
#endif

    "return (t>0.0)&&(t<tm);"
"}"



"vec3 calcnor(in vec4 ob,in vec4 ot,in vec3 po,out vec2 uv )"
"{"
    "vec3 no;"

    "if(ot.w>2.5)"
    //"if( col.w>0.5 )"
        "{"
        "no.xz=po.xz-ob.xz;"
        "no.y=0.0;"
        "no=no/ob.w;"
        //"uv=vec2(atan(no.x,no.z)/3.14159,po.y);"
        "uv=vec2(no.x,po.y+fpar00[12].w);"
        "}"
    "else if(ot.w>1.5)"
    //"else if( col.w>0.25 )"
        "{"
        "no=ob.xyz;"
        "uv=po.xz*.2;"
        "}"
    "else"
        "{"
        "no=po-ob.xyz;"
        "no=no/ob.w;"
        "uv=no.xy;"
        "}"

    //"no = normalize( no );"

    "return no;"
"}"


"float calcinter(in vec3 ro,in vec3 rd,out vec4 ob,out vec4 co)"
"{"
    "float tm=10000.0;"
    "float t;"
  
    //"col.w = -1.0;"
  
    "if(pri0(fpar00[0],ro,rd,tm,t))"
        "{"
        "ob=fpar00[0];"
        "co=fpar00[6];"
        "tm=t;"
        "}"

    "if(pri0(fpar00[1],ro,rd,tm,t))"
        "{"
        "ob=fpar00[1];"
        "co=fpar00[7];"
        "tm=t;"
        "}"

    "if(pri1(fpar00[2],ro,rd,tm,t))"
        "{"
        "ob=fpar00[2];"
        "co=fpar00[8];"
        "tm=t;"
        "}"

    "if(pri1(fpar00[3],ro,rd,tm,t))"
        "{"
        "ob=fpar00[3];"
        "co=fpar00[9];"
        "tm=t;"
        "}"

    "if(pri2(fpar00[4],ro,rd,tm,t))"
        "{"
        "ob=fpar00[4];"
        "co=fpar00[10];"
        "tm=t;"
        "}"

    "if(pri2(fpar00[5],ro,rd,tm,t))"
        "{"
        "ob=fpar00[5];"
        "co=fpar00[11];"
        "tm=t;"
        "}"

    "return tm;"
"}"


"bool calcshadow(in vec3 ro,in vec3 rd,in float l)"
"{"
    "float t;"

    "bvec4 ss = bvec4(pri0(fpar00[0],ro,rd,l,t),"
                     "pri0(fpar00[1],ro,rd,l,t),"
                     "pri1(fpar00[2],ro,rd,l,t),"
                     "pri1(fpar00[3],ro,rd,l,t));"

    "return any(ss);"
"}"


"vec4 calcshade(in vec3 po,in vec4 ob,in vec4 co,in vec3 rd,out vec4 re)"
"{"
    "float di,sp;"
    "vec2 uv;"
    "vec3 no;"
    "vec4 lz;"

    "lz.xyz=vec3(0.0,1.5,-3.0)-po;"
    "lz.w=length(lz.xyz);"
    "lz.xyz=lz.xyz/lz.w;"

    "no=calcnor(ob,co,po,uv);"

    "di=dot(no,lz.xyz);"
    "re.xyz=reflect(rd,no);"
    "sp=dot(re.xyz,lz.xyz);"
    "sp=max(sp,0.0);"
    "sp=sp*sp;"
    "sp=sp*sp;"

    "if(calcshadow(po,lz.xyz,lz.w))"
        "di=0.0;"

    "di=max(di,0.0);"
    //"co=co*texture2D(tex00,uv)*(vec4(.3,.34,.38,1)+.5*vec4(1.0,.95,.8,1.0)*di)+.5*sp;"
    "co=co*texture2D(tex00,uv)*(vec4(.21,.28,.3,1)+.5*vec4(1.0,.9,.65,1.0)*di)+sp;"

    // fresnel
    "di=dot(no,-rd);"
    "re.w=di;"
    "di=1.0-di*di;"
    "di=di*di;"

    //"return(co+.5*vec4(di));"
    "return(co+0.6*vec4(di));"
"}"



"void main( void )"
"{"
    "float tm;"
    "vec4 ob,co,co2,re,re2;"
    "vec3 no,po;"
    "vec3 ro=fpar00[12].xyz;"
    "vec3 rd=normalize(raydir);"

    "tm=calcinter(ro,rd,ob,co);"

    "po=ro+rd*tm;"
    "co=calcshade(po,ob,co,rd,re);"

    "tm=calcinter(po,re.xyz,ob,co2);"
    "po+=re.xyz*tm;"
    "co2=calcshade(po,ob,co2,re.xyz,re2);"
    "gl_FragColor=mix(co,co2,.5-.5*re.w) + vec4(fpar00[13].w);"
"}";


//=========================================================================


static char ray2_vertesxhader[] = \

"varying vec3 raydir;"
"uniform vec4 fpar00[16];"

"void main( void )"
"{"
    "vec3 r;"

    "gl_Position=gl_Vertex;"

    // create ray
    #if 0
    "r.x=gl_Vertex.x*1.3333;" 
    "r.y=gl_Vertex.y;"
    "r.z=-1.0;"
    #else
    "r = gl_Vertex.xyz*vec3(1.777,1.0,0.0)+vec3(0.0,0.0,-1.0);"
    #endif
    // transform raydir
    "raydir.x=dot(r,fpar00[13].xyz);"
    "raydir.y=dot(r,fpar00[14].xyz);"
    "raydir.z=dot(r,fpar00[15].xyz);"
"}";



#include <math.h>

#define XX_X fparams[2*24+ 4]
#define YY_X fparams[2*24+ 5]
#define ZZ_X fparams[2*24+ 6]
#define XX_Y fparams[2*24+ 8]
#define YY_Y fparams[2*24+ 9]
#define ZZ_Y fparams[2*24+10]
#define XX_Z fparams[2*24+12]
#define YY_Z fparams[2*24+13]
#define ZZ_Z fparams[2*24+14]

#define POS_X fparams[2*24+ 0]
#define POS_Y fparams[2*24+ 1]
#define POS_Z fparams[2*24+ 2]
#define POS_T fparams[2*24+ 3]
#define FLASH fparams[2*24+ 7]

#define NUMSALTOS 9
static int   saltosT[NUMSALTOS]  = {   0, 9600, 13000, 26000, 31900, 45000, 51200, 57400, 64000 };
static int   saltosA[NUMSALTOS]  = {   0, 9600, 30000,     0, 20000,168000, 10000,  2000,     0 };
static short duration[NUMSALTOS] = {1500,  333,     0,   333,    50,     0,     0,   800,  1000 };
static char  doFlash[NUMSALTOS]  = {  -1,   -1,     0,     1,    -1,     0,     0,    -1,     1 };
__forceinline void conf_rayclassic( float *fparams, long time )
{
    float up[2];


    // by default, no flash
    FLASH = 0.0f;

    // synchronization
    int salto = 0;
    int sec = 0;
    for( int i=0; i<NUMSALTOS; i++ )
        {
        // determine section, and jump
        if( time>saltosT[sec] )
            salto = saltosA[sec++];

        // flash
        const float fl = (float)(time-saltosT[i])/(float)duration[i];
        if( fabsf(fl)<1.570796326f )
            FLASH = (float)doFlash[i]*1.25f*cosf(fl);
        }
    time += salto;


    // time
    const float t = .001f*(float)time;

    // camera roll
    float roll = 0.2f*t;

    if( sec<4 || sec>=8)
        {
        // uv map offset
        POS_T = t;

        // s1: far away
        fparams[ 0] =  5.0f;

        // s2
        fparams[ 4] = -1.0f;
        fparams[ 5] =  0.6f;
        fparams[ 6] =  0.1f;
        fparams[ 7] =  0.08f;

        // c1: reverse
        fparams[11] = -0.4f;    

        // c2: move
        fparams[12] =-1.0f;
        //fparams[13] = 0.0f;
        fparams[14] = 0.1f;
        fparams[15] = 0.05f;

        // camera
        POS_X = -1.2f;
        POS_Y =  0.9f;
        POS_Z =  0.0f;

        }
    else if( sec==4 || sec==6)
        {
        POS_T = 0.0f;
        // c1: normal
        fparams[11] = 0.4f;

        // c2: move
        fparams[12] = 1.2f;
        //fparams[13] = 0.0f;
        fparams[14] = 0.0f;
        fparams[15] = 0.4f;

        roll = 0.0f;
        POS_X = -3.0f*cosf( 1.5f*0.29f*(t-26.0f) );
        POS_Y = 1.8f;
        POS_Z = -3.0f*sinf( 1.5f*0.31f*(t-26.0f) );


        if( sec==6 )
            {
            fparams[ 0] = 2.2f*sinf(.75f*3.6f*t+1.2f);
            fparams[ 1] = 1.2f*sinf(.75f*5.5f*t+1.0f);
            fparams[ 2] = 2.6f*sinf(.75f*4.4f*t+0.8f);
            // s2
            fparams[ 4] = 2.2f*sinf(.75f*4.3f*t+0.6f);
            fparams[ 5] = 1.2f*sinf(.75f*5.2f*t+0.4f);
            fparams[ 6] = 2.6f*sinf(.75f*3.1f*t+0.0f);
            }

        }
    else if( sec==5 || sec==7)
        {
        // camera
        float s, r;
        s = 3.0f;
        r = 2.5f;

        POS_X = r*cosf( .1f*t );
        POS_Y =   sinf( .1f*t );
        POS_Z = -2.0f;

        
        r = sinf(6.2831f*0.25f*10.0f*t);
        r = .5f + .5f*r;
        r = r*r;
        r = r*r;
        r = r*r;
        s = 0.1f + 0.4f*r;
        fparams[15] = s;
        fparams[11] = s;

        s = 0.5f - 0.4f*r;
        // s1
        fparams[ 0] = -1.2f;
        fparams[ 1] = 2.0f*r;
        fparams[ 2] = 0.0f;

        // s2
        fparams[ 4] = 1.2f;
        fparams[ 5] = -2.0f*r;
        fparams[ 6] = 0.0f;
        fparams[ 7] = 0.6f;
        }

    //-------------------------

    ZZ_X = POS_X;
    ZZ_Y = POS_Y;
    ZZ_Z = POS_Z;

/*
    #if defined(WINDOWS) && defined (A32BITS)
    _asm
    {
        fld dword ptr [roll];
        fsincos
        fstp dword ptr [up+4]
        fstp dword ptr [up+0]
    }
    #else*/
    up[0] = sinf( roll );
    up[1] = cosf( roll );    
    //#endif

    float im = ZZ_X*ZZ_X + ZZ_Y*ZZ_Y + ZZ_Z*ZZ_Z;
    im = 1.0f/sqrtf( im );
    ZZ_X *= im;
    ZZ_Y *= im;
    ZZ_Z *= im;

    XX_X =            - up[1]*ZZ_Z;
    XX_Y = up[0]*ZZ_Z             ;
    XX_Z = up[1]*ZZ_X - up[0]*ZZ_Y;

    YY_X = XX_Z*ZZ_Y - XX_Y*ZZ_Z;
    YY_Y = XX_X*ZZ_Z - XX_Z*ZZ_X;
    YY_Z = XX_Y*ZZ_X - XX_X*ZZ_Y;
}

