#include <math.h>
#include "../m3d/math3d.h"

//---------------------------------------------------------------------------

int INDEX_2D( int ix, int iy)
{
    return ((ix+1)*(iy+1)*16807) & 255;
}

float flerp( float t, float x0, float x1 )
{
    return x0 + t*(x1-x0);
}
/*
int ilerp( int t, int x0, int x1 )
{
    return x0 + ((t*(x1-x0))>>10);
}
*/

float noise2d( float x, float y, int pe )
{
    pe--;

#if 1
  int   ix, iy;
  float fx, fy, re;
  float vy0, vy1;
  int   ix1, iy1;


  #if defined(WINDOWS) && defined (A32BITS)
      //static unsigned int conf2 = 0x003f;
      static unsigned int conf1 = 0x043f;
      unsigned int conf2;
      _asm
          {
          fstcw   word ptr conf2
          fldcw   word ptr conf1

          fld     dword ptr x
          fistp   dword ptr ix
          fld     dword ptr y
          fistp   dword ptr iy

          fldcw   word ptr conf2
          }
  #else
      ix = 
      iy = 
  #endif

  fx = x - (float)ix;
  fy = y - (float)iy;

  ix &= pe;
  iy &= pe;

  ix1 = (ix+1)&pe;
  iy1 = (iy+1)&pe;

  vy0 = flerp(fx, (float)INDEX_2D(ix, iy ), (float)INDEX_2D(ix1,iy ));
  vy1 = flerp(fx, (float)INDEX_2D(ix, iy1), (float)INDEX_2D(ix1,iy1));

  re = flerp(fy, vy0, vy1);
  re = (1.0f/255.0f)*re;

  return re;

#else

  int   fx, fy, re;
  int   ix0, iy0;
  int   ix1, iy1;

  ix0 = (int)(1024.0f*x);
  iy0 = (int)(1024.0f*y);

  fx = ix0 & 1023;
  fy = iy0 & 1023;

  ix0 >>= 10;
  iy0 >>= 10;
  
  ix0 &= pe;
  iy0 &= pe;

  ix1 = (ix0+1)&pe;
  iy1 = (iy0+1)&pe;

  re = ilerp(fy, ilerp(fx, INDEX_2D(ix0, iy0), INDEX_2D(ix1,iy0)), 
                 ilerp(fx, INDEX_2D(ix0, iy1), INDEX_2D(ix1,iy1)) );
  
/*
  int a = INDEX_2D(ix0, iy0);
  int b = INDEX_2D(ix1, iy0);
  int c = INDEX_2D(ix0, iy1);
  int d = INDEX_2D(ix1, iy1);
  re = a + ((fx*(b-a) + fy*(c-a))>>10) + ((fx*fy*(a+d-b-c))>>20);
*/


  return (1.0f/255.0f)*(float)re;
#endif
}






float TURB_Turbulence( float x, float y, int pe )
{
    float   t, s;
    int     i;

    x *= (float)pe;
    y *= (float)pe;

    t = 0.0f;
    s = 0.5f;

    for( i=0; i<6; i++ )
        {
        t += s*noise2d( x, y, pe );
        x+=x;
        y+=y;
        s*=.5f;
        pe += pe;
        }

    return( t );
}


