//--------------------------------------------------------------------------//
// iq . 2003 . code for the Paradise 64 kb intro by RGBA                    //
//--------------------------------------------------------------------------//

#ifdef WINDOWS
#define WIN32_LEAN_AND_MEAN
#define WIN32_EXTRA_LEAN
#include <windows.h>
#endif
#include <GL/gl.h>
#include "glext.h"
#ifdef LINUX
#include <GL/glx.h>
#endif
#ifdef IRIX
#include <GL/glx.h>
#endif

#include <string.h>

//--- d a t a ---------------------------------------------------------------

#ifdef DEBUG
#define NUMFUNCIONES    (12)
#else
#define NUMFUNCIONES    (9)
#endif

static char *funciones = {

	// high level shader
	"glCreateProgramObjectARB\x0"
	"glCreateShaderObjectARB\x0"
	"glShaderSourceARB\x0"
	"glCompileShaderARB\x0"
	"glAttachObjectARB\x0"
	"glLinkProgramARB\x0"
	"glUseProgramObjectARB\x0"
    "glUniform4fvARB\x0"
    "glUniform1iARB\x0"
    #ifdef DEBUG
    "glGetUniformLocationARB\x0"
	"glGetObjectParameterivARB\x0"
	"glGetInfoLogARB\x0"
    #endif
    };
/*
static unsigned char lengths[NUMFUNCIONES] = {
24-14,23-14,17-14,18-14,17-14,16-14,21-14,15-14,14-14,
#ifdef DEBUG
23-14,25-14,15-14
#endif
};
*/
void *myglfunc[NUMFUNCIONES];

int EXT_Init( void )
{
    char *str;
	void *direccion;
    int  i;

    str = funciones;
    for( i=0; i<NUMFUNCIONES; i++ )
        {
        #ifdef WINDOWS
        direccion = (void *)wglGetProcAddress( str );
        #endif
        #ifdef LINUX
        direccion = (void *)glXGetProcAddress( (const unsigned char *)str );
        #endif
        #ifdef IRIX
        direccion = (void *)glXGetProcAddress( (const unsigned char *)str );
        #endif

        str += 1+strlen( str );
        //str += 15+lengths[i];

        if( !direccion )
			return( 0 );

        myglfunc[i] = direccion;
        }

    return( 1 );
}


